#-----------------------------------------------------------------------------
# Toggle Visibility by name
# Jan 9,06
# Copyright (c) 2006 by David G. Drumright (ockham)
#-----------------------------------------------------------------------------

import poser
import string
scene=poser.Scene()

from Tkinter import *

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Fill in name (or partial name) to toggle visibility.")

        self.StatusEntry = Entry(self.master,width=60)
        self.StatusEntry.grid(row=0,column=0,columnspan=2)

        self.buttonGo = Button(self.master, text="Toggle", command=self.HandleGo)
        self.buttonGo.grid(row=3, column=1)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    def HandleGo(self):
        Name=self.StatusEntry.get()
        if not Name: return
        Name=string.upper(Name)

        for A in scene.Actors():
            Aname=string.upper(A.Name())
            if string.count(Aname,Name):
                A.SetOnOff(1-A.OnOff())
        scene.DrawAll()

    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents(1)
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
